import requests

from client.session import ClientSession
from client.error import SessionNotCreatedException, IncorrectUsernameOrPasswordException, SppNotRunningException


class Client:

	def create_session(self, username, password):

		try:
			url = 'http://localhost:8082/api/endeavour/session?screenInfo=1'
			headers = {
				'Accept': 'application/json',
				'Content-Type': 'application/json'
			}

			response = requests.post(url, headers=headers, auth=(username, password))
			status_code = response.status_code
			json = response.json()

			if status_code == 200:

				if 'sessionid' in json:
					return ClientSession(json['sessionid'])
				
				else:
					raise SessionNotCreatedException('Failed to created SPP session.')
			
			elif response.status_code == 401:

				if 'id' in json and json['id'] == 'XSBAuthenticationException':
					raise IncorrectUsernameOrPasswordException('Incorrect SPP username or password')

		except ConnectionError:
			raise SppNotRunningException('SPP API is not reachable. Ensure SPP is running and reachable.')
